/*
  Copyright (c) 2013 by Switch Science (sales at switch-science.com)
  Cypress(Ramtron) FM25W256 SPI F-RAM library for Arduino

  Original library is
    Copyright (c) 2010 by arms22 (arms22 at gmail.com)
    Microchip 23x256 SPI SRAM library for Arduino

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
*/

#ifndef SPIFRAM_H
#define SPIFRAM_H

#include <SPI.h>

class SPIFRAM
{
public:
	struct MemCell {
		SPIFRAM &device;
		unsigned int address;
		MemCell &operator=(byte data){
			device.write(address,data);
			return *this;
		}
		operator byte() {
			return device.read(address);
		}
		MemCell(SPIFRAM &d,unsigned int a) : device(d), address(a) {};
		~MemCell(){};
	};
	MemCell operator[](unsigned int address){
		MemCell memcell(*this,address);
		return memcell;
	}
	SPIFRAM(byte ncsPin);
	byte read(unsigned int address);
	void read(unsigned int address, byte *buffer, unsigned int size);
	void write(unsigned int address, byte data);
	void write(unsigned int address, byte *buffer, unsigned int size);
private:
	byte _ncsPin;
	byte _buf[4];
	void select(void);
	void deselect(void);
	byte transfer(byte length);
};

#endif
